pcl::poisson::Octree< Degree > Class Template Reference

`#include <pcl/surface/3rdparty/poisson4/multi_grid_octree_data.h>`

## Public Member Functions

| Octree (void)
void | setBSplineData (int maxDepth, Real normalSmooth=-1, bool reflectBoundary=false)
void | finalize (void)
void | RefineBoundary (int subdivisionDepth)
Real * | GetWeightGrid (int &res, int depth=-1)
Real * | GetSolutionGrid (int &res, float isoValue=0.f, int depth=-1)
template<typename PointNT >
int | setTree (typename pcl::PointCloud< PointNT >::ConstPtr input_, int maxDepth, int minDepth, int kernelDepth, Real samplesPerNode, Real scaleFactor, Point3D< Real > &center, Real &scale, int useConfidence, Real constraintWeight, bool adaptiveWeights)
void | SetLaplacianConstraints (void)
void | ClipTree (void)
int | LaplacianMatrixIteration (int subdivideDepth, bool showResidual, int minIters, double accuracy)
Real | GetIsoValue (void)
void | GetMCIsoTriangles (Real isoValue, int subdivideDepth, pcl::poisson::CoredMeshData *mesh, int fullDepthIso=0, int nonLinearFit=1, bool addBarycenter=false, bool polygonMesh=false)

## Static Public Member Functions

static double | MemoryUsage (void)

## Public Attributes

int | threads
std::vector< pcl::poisson::Point3D< Real > > * | normals
Real | postNormalSmooth
TreeOctNode | tree
pcl::poisson::BSplineData< Degree, BSplineDataReal > | fData

## Static Public Attributes

static double | maxMemoryUsage =0

## Detailed Description

### template<int Degree>
class pcl::poisson::Octree< Degree >

Definition at line 195 of file multi_grid_octree_data.h.

## Constructor & Destructor Documentation

## Octree()

template<int Degree>

pcl::poisson::Octree< Degree >::Octree | ( | void |  | ) |

Definition at line 528 of file multi_grid_octree_data.hpp.

## Member Function Documentation

## ClipTree()

template<int Degree>

void pcl::poisson::Octree< Degree >::ClipTree | ( | void |  | ) |

Definition at line 2105 of file multi_grid_octree_data.hpp.

References pcl::poisson::Cube::CORNERS, pcl::poisson::EPSILON, and pcl::poisson::OctNode< NodeData, Real >::nextNode().

## finalize()

template<int Degree>

void pcl::poisson::Octree< Degree >::finalize | ( | void |  | ) |

Definition at line 990 of file multi_grid_octree_data.hpp.

References pcl::poisson::Cube::FactorCornerIndex(), pcl::poisson::SortedTreeNodes::maxDepth, and pcl::poisson::OctNode< NodeData, Real >::nextNode().

## GetIsoValue()

template<int Degree>

Real pcl::poisson::Octree< Degree >::GetIsoValue | ( | void |  | ) |

Definition at line 2788 of file multi_grid_octree_data.hpp.

References pcl::poisson::TreeNodeData::centerWeightContribution, and pcl::poisson::OctNode< NodeData, Real >::nodeData.

## GetMCIsoTriangles()

template<int Degree>

void pcl::poisson::Octree< Degree >::GetMCIsoTriangles | ( | Real | isoValue,
|  | int | subdivideDepth,
|  | pcl::poisson::CoredMeshData * | mesh,
|  | int | fullDepthIso = `0`,
|  | int | nonLinearFit = `1`,
|  | bool | addBarycenter = `false`,
|  | bool | polygonMesh = `false`
| ) |  |

Definition at line 2425 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::Cube::CornerIndex(), pcl::poisson::OctNode< NodeData, Real >::d, pcl::poisson::OctNode< NodeData, Real >::depthAndOffset(), pcl::poisson::MarchingCubes::HasRoots(), pcl::poisson::TreeNodeData::mcIndex, pcl::poisson::OctNode< NodeData, Real >::nextLeaf(), pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::CoredMeshData::outOfCorePointCount(), and pcl::poisson::OctNode< NodeData, Real >::parent.

## GetSolutionGrid()

template<int Degree>

Real * pcl::poisson::Octree< Degree >::GetSolutionGrid | ( | int & | res,
|  | float | isoValue = `0.f`,
|  | int | depth = `-1`
| ) |  |

Definition at line 3762 of file multi_grid_octree_data.hpp.

References pcl::poisson::BinaryNode< Real >::CenterIndex(), pcl::poisson::BSplineData< Degree, Real >::functionCount, pcl::poisson::OctNode< NodeData, Real >::nextNode(), pcl::poisson::BSplineData< Degree, Real >::set(), pcl::poisson::BSplineData< Degree, Real >::setSampleSpan(), pcl::poisson::BSplineData< Degree, Real >::setValueTables(), pcl::poisson::BSplineData< Degree, Real >::VALUE_FLAG, and pcl::poisson::BSplineData< Degree, Real >::valueTables.

## GetWeightGrid()

template<int Degree>

Real * pcl::poisson::Octree< Degree >::GetWeightGrid | ( | int & | res,
|  | int | depth = `-1`
| ) |  |

Definition at line 3806 of file multi_grid_octree_data.hpp.

References pcl::poisson::BinaryNode< Real >::CenterIndex(), and pcl::poisson::OctNode< NodeData, Real >::nextNode().

## LaplacianMatrixIteration()

template<int Degree>

int pcl::poisson::Octree< Degree >::LaplacianMatrixIteration | ( | int | subdivideDepth,
|  | bool | showResidual,
|  | int | minIters,
|  | double | accuracy
| ) |  |

Definition at line 1886 of file multi_grid_octree_data.hpp.

References pcl::poisson::SparseMatrix< T >::SetAllocator().

## MemoryUsage()

template<int Degree>

double pcl::poisson::Octree< Degree >::MemoryUsage | ( | void |  | ) |

static

Definition at line 521 of file multi_grid_octree_data.hpp.

## RefineBoundary()

template<int Degree>

void pcl::poisson::Octree< Degree >::RefineBoundary | ( | int | subdivisionDepth | ) |

Definition at line 2358 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::nextLeaf().

## setBSplineData()

template<int Degree>

void pcl::poisson::Octree< Degree >::setBSplineData | ( | int | maxDepth,
|  | Real | normalSmooth = `-1`,
|  | bool | reflectBoundary = `false`
| ) |  |

Definition at line 981 of file multi_grid_octree_data.hpp.

References pcl::poisson::EPSILON, and pcl::poisson::SortedTreeNodes::maxDepth.

## SetLaplacianConstraints()

template<int Degree>

void pcl::poisson::Octree< Degree >::SetLaplacianConstraints | ( | void |  | ) |

Definition at line 2118 of file multi_grid_octree_data.hpp.

References pcl::poisson::TreeNodeData::centerWeightContribution, pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::TreeNodeData::constraint, pcl::poisson::OctNode< NodeData, Real >::depth(), pcl::poisson::OctNode< NodeData, Real >::depthAndOffset(), pcl::poisson::Cube::FactorCornerIndex(), pcl::poisson::Length(), pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::nodeIndex, pcl::poisson::TreeNodeData::normalIndex, and pcl::poisson::OctNode< NodeData, Real >::parent.

## setTree()

template<int Degree>
template<typename PointNT >

int pcl::poisson::Octree< Degree >::setTree | ( | typename pcl::PointCloud< PointNT >::ConstPtr | input_,
|  | int | maxDepth,
|  | int | minDepth,
|  | int | kernelDepth,
|  | Real | samplesPerNode,
|  | Real | scaleFactor,
|  | Point3D< Real > & | center,
|  | Real & | scale,
|  | int | useConfidence,
|  | Real | constraintWeight,
|  | bool | adaptiveWeights
| ) |  |

Definition at line 763 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::OctNode< class TreeNodeData, Real >::CornerIndex(), pcl::poisson::EPSILON, pcl::poisson::OctNode< NodeData, Real >::initChildren(), pcl::poisson::Length(), pcl::poisson::SortedTreeNodes::maxDepth, pcl::poisson::OctNode< NodeData, Real >::nextNode(), pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::pointIndex, pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::size(), and pcl::poisson::TreeNodeData::UseIndex.

## Member Data Documentation

## fData

template<int Degree>

pcl::poisson::BSplineData<Degree,BSplineDataReal> pcl::poisson::Octree< Degree >::fData

Definition at line 341 of file multi_grid_octree_data.h.

## maxMemoryUsage

template<int Degree>

double pcl::poisson::Octree< Degree >::maxMemoryUsage =0

static

Definition at line 336 of file multi_grid_octree_data.h.

## normals

template<int Degree>

std::vector< pcl::poisson::Point3D<Real> >* pcl::poisson::Octree< Degree >::normals

Definition at line 338 of file multi_grid_octree_data.h.

## postNormalSmooth

template<int Degree>

Real pcl::poisson::Octree< Degree >::postNormalSmooth

Definition at line 339 of file multi_grid_octree_data.h.

## threads

template<int Degree>

int pcl::poisson::Octree< Degree >::threads

Definition at line 335 of file multi_grid_octree_data.h.

## tree

template<int Degree>

TreeOctNode pcl::poisson::Octree< Degree >::tree

Definition at line 340 of file multi_grid_octree_data.h.

The documentation for this class was generated from the following files:

- pcl/surface/3rdparty/poisson4/multi_grid_octree_data.h
- pcl/surface/3rdparty/poisson4/multi_grid_octree_data.hpp